xgboost

Public Member Functions | Public Attributes | Static Public Attributes | List of all members
xgboost::MetaInfo Class Reference

Meta information about dataset, always sit in memory. More...

`#include <data.h>`

Collaboration diagram for xgboost::MetaInfo:

## Public Member Functions
| MetaInfo ()=default
| default constructor More...
| MetaInfo (MetaInfo &&that)=default
MetaInfo & | operator= (MetaInfo &&that)=default
MetaInfo & | operator= (MetaInfo const &that)=delete
void | Validate (int32_t device) const
| Validate all metainfo. More...
MetaInfo | Slice (common::Span< int32_t const > ridxs) const
bst_float | GetWeight (size_t i) const
| Get weight of each instances. More...
const std::vector< size_t > & | LabelAbsSort () const
| get sorted indexes (argsort) of labels by absolute value (used by cox loss) More...
void | Clear ()
| clear all the information More...
void | LoadBinary (dmlc::Stream *fi)
| Load the Meta info from binary stream. More...
void | SaveBinary (dmlc::Stream *fo) const
| Save the Meta info to binary stream. More...
void | SetInfo (Context const &ctx, const char *key, const void *dptr, DataType dtype, size_t num)
| Set information in the meta info. More...
void | SetInfo (Context const &ctx, StringView key, StringView interface_str)
| Set information in the meta info with array interface. More...
void | GetInfo (char const *key, bst_ulong *out_len, DataType dtype, const void **out_dptr) const
void | SetFeatureInfo (const char *key, const char **info, const bst_ulong size)
void | GetFeatureInfo (const char *field, std::vector< std::string > *out_str_vecs) const
void | Extend (MetaInfo const &that, bool accumulate_rows, bool check_column)

## Public Attributes
uint64_t | num_row_ {0}
| number of rows in the data More...
uint64_t | num_col_ {0}
| number of columns in the data More...
uint64_t | num_nonzero_ {0}
| number of nonzero entries in the data More...
linalg::Tensor< float, 2 > | labels
| label of each instance More...
std::vector< bst_group_t > | group_ptr_
| the index of begin and end of a group needed when the learning task is ranking. More...
HostDeviceVector< bst_float > | weights_
| weights of each instance, optional More...
linalg::Tensor< float, 2 > | base_margin_
| initialized margins, if specified, xgboost will start from this init margin can be used to specify initial prediction to boost from. More...
HostDeviceVector< bst_float > | labels_lower_bound_
| lower bound of the label, to be used for survival analysis (censored regression) More...
HostDeviceVector< bst_float > | labels_upper_bound_
| upper bound of the label, to be used for survival analysis (censored regression) More...
std::vector< std::string > | feature_type_names
| Name of type for each feature provided by users. Eg. "int"/"float"/"i"/"q". More...
std::vector< std::string > | feature_names
| Name for each feature. More...
HostDeviceVector< FeatureType > | feature_types
HostDeviceVector< float > | feature_weights

## Static Public Attributes
static constexpr uint64_t | kNumField = 12
| number of data fields in MetaInfo More...

## Detailed Description

Meta information about dataset, always sit in memory.

## Constructor & Destructor Documentation

## ◆ MetaInfo() [1/2]

xgboost::MetaInfo::MetaInfo | ( |  | ) |
| default

default constructor

## ◆ MetaInfo() [2/2]

xgboost::MetaInfo::MetaInfo | ( | MetaInfo && | that | ) |
| default

## Member Function Documentation

## ◆ Clear()

void xgboost::MetaInfo::Clear | ( |  | ) |

clear all the information

## ◆ Extend()

void xgboost::MetaInfo::Extend | ( | MetaInfo const & | that,
|  | bool | accumulate_rows,
|  | bool | check_column
| ) |  |

## ◆ GetFeatureInfo()

void xgboost::MetaInfo::GetFeatureInfo | ( | const char * | field,
|  | std::vector< std::string > * | out_str_vecs
| ) |  | const

## ◆ GetInfo()

void xgboost::MetaInfo::GetInfo | ( | char const * | key,
|  | bst_ulong * | out_len,
|  | DataType | dtype,
|  | const void ** | out_dptr
| ) |  | const

## ◆ GetWeight()

bst_float xgboost::MetaInfo::GetWeight | ( | size_t | i | ) | const
| inline

Get weight of each instances.

Parameters

  i | Instance index.

Returns
  The weight.

## ◆ LabelAbsSort()

const std::vector<size_t>& xgboost::MetaInfo::LabelAbsSort | ( |  | ) | const
| inline

get sorted indexes (argsort) of labels by absolute value (used by cox loss)

## ◆ LoadBinary()

void xgboost::MetaInfo::LoadBinary | ( | dmlc::Stream * | fi | ) |

Load the Meta info from binary stream.

Parameters

  fi | The input stream

## ◆ operator=() [1/2]

MetaInfo& xgboost::MetaInfo::operator= | ( | MetaInfo && | that | ) |
| default

## ◆ operator=() [2/2]

MetaInfo& xgboost::MetaInfo::operator= | ( | MetaInfo const & | that | ) |
| delete

## ◆ SaveBinary()

void xgboost::MetaInfo::SaveBinary | ( | dmlc::Stream * | fo | ) | const

Save the Meta info to binary stream.

Parameters

  fo | The output stream.

## ◆ SetFeatureInfo()

void xgboost::MetaInfo::SetFeatureInfo | ( | const char * | key,
|  | const char ** | info,
|  | const bst_ulong | size
| ) |  |

## ◆ SetInfo() [1/2]

void xgboost::MetaInfo::SetInfo | ( | Context const & | ctx,
|  | const char * | key,
|  | const void * | dptr,
|  | DataType | dtype,
|  | size_t | num
| ) |  |

Set information in the meta info.

Parameters

  key | The key of the information.
  dptr | The data pointer of the source array.
  dtype | The type of the source data.
  num | Number of elements in the source array.

## ◆ SetInfo() [2/2]

void xgboost::MetaInfo::SetInfo | ( | Context const & | ctx,
|  | StringView | key,
|  | StringView | interface_str
| ) |  |

Set information in the meta info with array interface.

Parameters

  key | The key of the information.
  interface_str | String representation of json format array interface.

## ◆ Slice()

MetaInfo xgboost::MetaInfo::Slice | ( | common::Span< int32_t const > | ridxs | ) | const

## ◆ Validate()

void xgboost::MetaInfo::Validate | ( | int32_t | device | ) | const

Validate all metainfo.

## Member Data Documentation

## ◆ base_margin_

linalg::Tensor<float, 2> xgboost::MetaInfo::base_margin_

initialized margins, if specified, xgboost will start from this init margin can be used to specify initial prediction to boost from.

## ◆ feature_names

std::vector<std::string> xgboost::MetaInfo::feature_names

Name for each feature.

## ◆ feature_type_names

std::vector<std::string> xgboost::MetaInfo::feature_type_names

Name of type for each feature provided by users. Eg. "int"/"float"/"i"/"q".

## ◆ feature_types

HostDeviceVector<FeatureType> xgboost::MetaInfo::feature_types

## ◆ feature_weights

HostDeviceVector<float> xgboost::MetaInfo::feature_weights

## ◆ group_ptr_

std::vector<bst_group_t> xgboost::MetaInfo::group_ptr_

the index of begin and end of a group needed when the learning task is ranking.

## ◆ kNumField

constexpr uint64_t xgboost::MetaInfo::kNumField = 12
| static constexpr

number of data fields in MetaInfo

## ◆ labels

linalg::Tensor<float, 2> xgboost::MetaInfo::labels

label of each instance

## ◆ labels_lower_bound_

HostDeviceVector<bst_float> xgboost::MetaInfo::labels_lower_bound_

lower bound of the label, to be used for survival analysis (censored regression)

## ◆ labels_upper_bound_

HostDeviceVector<bst_float> xgboost::MetaInfo::labels_upper_bound_

upper bound of the label, to be used for survival analysis (censored regression)

## ◆ num_col_

uint64_t xgboost::MetaInfo::num_col_ {0}

number of columns in the data

## ◆ num_nonzero_

uint64_t xgboost::MetaInfo::num_nonzero_ {0}

number of nonzero entries in the data

## ◆ num_row_

uint64_t xgboost::MetaInfo::num_row_ {0}

number of rows in the data

## ◆ weights_

HostDeviceVector<bst_float> xgboost::MetaInfo::weights_

weights of each instance, optional

The documentation for this class was generated from the following file:

- /home/runner/work/xgboost/xgboost/include/xgboost/data.h